<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ServiceElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ServiceElement extends AbstractStructArrayBase
{
    /**
     * The ServiceElement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ServiceElement[]
     */
    public $ServiceElement;
    /**
     * Constructor method for ArrayOfJP_ServiceElement
     * @uses ArrayOfJP_ServiceElement::setServiceElement()
     * @param \StructType\JP_ServiceElement[] $serviceElement
     */
    public function __construct(array $serviceElement = array())
    {
        $this
            ->setServiceElement($serviceElement);
    }
    /**
     * Get ServiceElement value
     * @return \StructType\JP_ServiceElement[]|null
     */
    public function getServiceElement()
    {
        return $this->ServiceElement;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceElement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceElement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceElementForArrayConstraintsFromSetServiceElement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_ServiceElementServiceElementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ServiceElementServiceElementItem instanceof \StructType\JP_ServiceElement) {
                $invalidValues[] = is_object($arrayOfJP_ServiceElementServiceElementItem) ? get_class($arrayOfJP_ServiceElementServiceElementItem) : sprintf('%s(%s)', gettype($arrayOfJP_ServiceElementServiceElementItem), var_export($arrayOfJP_ServiceElementServiceElementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceElement property can only contain items of type \StructType\JP_ServiceElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceElement[] $serviceElement
     * @return \ArrayType\ArrayOfJP_ServiceElement
     */
    public function setServiceElement(array $serviceElement = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceElementArrayErrorMessage = self::validateServiceElementForArrayConstraintsFromSetServiceElement($serviceElement))) {
            throw new \InvalidArgumentException($serviceElementArrayErrorMessage, __LINE__);
        }
        $this->ServiceElement = $serviceElement;
        return $this;
    }
    /**
     * Add item to ServiceElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceElement $item
     * @return \ArrayType\ArrayOfJP_ServiceElement
     */
    public function addToServiceElement(\StructType\JP_ServiceElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ServiceElement) {
            throw new \InvalidArgumentException(sprintf('The ServiceElement property can only contain items of type \StructType\JP_ServiceElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceElement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ServiceElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ServiceElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ServiceElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ServiceElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ServiceElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceElement
     */
    public function getAttributeName()
    {
        return 'ServiceElement';
    }
}
